/**
   \file
   \author Shin'ichiro Nakaoka
*/

#ifndef CNOID_BASE_OSG_SCENE_ITEM_H_INCLUDED
#define CNOID_BASE_OSG_SCENE_ITEM_H_INCLUDED

#include "Item.h"
#include "OSGSceneObject.h"
#include "exportdecl.h"

namespace cnoid {
        
    class CNOID_EXPORT OSGSceneItem : public Item
    {
      public:
        static void initialize(ExtensionManager* ext);

        OSGSceneItem();
        OSGSceneItem(const OSGSceneItem& org);
        virtual ~OSGSceneItem();

        inline OSGSceneObject* sceneObject() { return sceneObject_.get(); }

        OSGSceneObject::ReadResult loadScene(const std::string& filename);

      protected:
        virtual void onDisconnectedFromRoot();
        virtual ItemPtr doDuplicate() const;
        virtual bool store(Archive& archive);
        virtual bool restore(const Archive& archive);
        virtual void doPutProperties(PutPropertyFunction& putProperty);
            
      private:
        OSGSceneObjectPtr sceneObject_;
    };

    typedef boost::intrusive_ptr<OSGSceneItem> OSGSceneItemPtr;


}

#endif
