/*!
  @file
  @author Shin'ichiro Nakaoka
*/

#include "ColdetLinkPair.h"
#include "Link.h"

using namespace cnoid;


ColdetLinkPair::ColdetLinkPair(const BodyPtr& body1, Link* link1, const BodyPtr& body2, Link* link2)
    : ColdetModelPair(link1->coldetModel(), link2->coldetModel())
{
    bodies[0] = body1;
    bodies[1] = body2;
    links[0] = link1;
    links[1] = link2;
}


ColdetLinkPair::ColdetLinkPair(const ColdetLinkPair& org)
    : ColdetModelPair(org)
{
    bodies[0] = org.bodies[0];
    bodies[1] = org.bodies[1];
    links[0] = org.links[0];
    links[1] = org.links[1];
}


ColdetLinkPair::~ColdetLinkPair()
{

}

void ColdetLinkPair::updatePositions()
{
    model(0)->setPosition(links[0]->T());
    model(1)->setPosition(links[1]->T());
}
