/*!
  @file
  @author Shin'ichiro Nakaoka
*/

#ifndef CNOID_ODEPLUGIN_ODE_SIMULATOR_ITEM_H_INCLUDED
#define CNOID_ODEPLUGIN_ODE_SIMULATOR_ITEM_H_INCLUDED

#include <cnoid/SimulatorItem>

namespace cnoid {

    class ODESimulatorItemImpl;
        
    class ODESimulatorItem : public SimulatorItem
    {
      public:

        static void initialize(ExtensionManager* ext);
        
        ODESimulatorItem();
        ODESimulatorItem(const ODESimulatorItem& org);
        virtual ~ODESimulatorItem();

        virtual void setAllLinkPositionOutputMode(bool on);

      protected:
        
        virtual SimulationBodyPtr createSimulationBody(const Body& orgBody);
        virtual bool initializeSimulation(const std::vector<SimulationBodyPtr>& simBodies);
        virtual void initializeSimulationThread();
        virtual bool stepSimulation(const std::vector<SimulationBodyPtr>& activeSimBodies);
        
        virtual ItemPtr doDuplicate() const;
        virtual void doPutProperties(PutPropertyFunction& putProperty);
        virtual bool store(Archive& archive);
        virtual bool restore(const Archive& archive);

      private:
        ODESimulatorItemImpl* impl;
        friend class ODESimulatorItemImpl;
    };

    typedef boost::intrusive_ptr<ODESimulatorItem> ODESimulatorItemPtr;
}

#endif
